# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import _utilities, _tables


class RegionNetworkEndpointGroup(pulumi.CustomResource):
    app_engine: pulumi.Output[dict]
    """
    Only valid when networkEndpointType is "SERVERLESS".
    Only one of cloud_run, app_engine or cloud_function may be set.
    Structure is documented below.

      * `service` (`str`) - Optional serving service.
        The service name must be 1-63 characters long, and comply with RFC1035.
        Example value: "default", "my-service".
      * `urlMask` (`str`) - A template to parse function field from a request URL. URL mask allows
        for routing to multiple Cloud Functions without having to create
        multiple Network Endpoint Groups and backend services.
        For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
        can be backed by the same Serverless NEG with URL mask "/". The URL mask
        will parse them to { function = "function1" } and { function = "function2" } respectively.
      * `version` (`str`) - Optional serving version.
        The version must be 1-63 characters long, and comply with RFC1035.
        Example value: "v1", "v2".
    """
    cloud_function: pulumi.Output[dict]
    """
    Only valid when networkEndpointType is "SERVERLESS".
    Only one of cloud_run, app_engine or cloud_function may be set.
    Structure is documented below.

      * `function` (`str`) - A user-defined name of the Cloud Function.
        The function name is case-sensitive and must be 1-63 characters long.
        Example value: "func1".
      * `urlMask` (`str`) - A template to parse function field from a request URL. URL mask allows
        for routing to multiple Cloud Functions without having to create
        multiple Network Endpoint Groups and backend services.
        For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
        can be backed by the same Serverless NEG with URL mask "/". The URL mask
        will parse them to { function = "function1" } and { function = "function2" } respectively.
    """
    cloud_run: pulumi.Output[dict]
    """
    Only valid when networkEndpointType is "SERVERLESS".
    Only one of cloud_run, app_engine or cloud_function may be set.
    Structure is documented below.

      * `service` (`str`) - Optional serving service.
        The service name must be 1-63 characters long, and comply with RFC1035.
        Example value: "default", "my-service".
      * `tag` (`str`) - Cloud Run tag represents the "named-revision" to provide
        additional fine-grained traffic routing information.
        The tag must be 1-63 characters long, and comply with RFC1035.
        Example value: "revision-0010".
      * `urlMask` (`str`) - A template to parse function field from a request URL. URL mask allows
        for routing to multiple Cloud Functions without having to create
        multiple Network Endpoint Groups and backend services.
        For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
        can be backed by the same Serverless NEG with URL mask "/". The URL mask
        will parse them to { function = "function1" } and { function = "function2" } respectively.
    """
    description: pulumi.Output[str]
    """
    An optional description of this resource. Provide this property when
    you create the resource.
    """
    name: pulumi.Output[str]
    """
    Name of the resource; provided by the client when the resource is
    created. The name must be 1-63 characters long, and comply with
    RFC1035. Specifically, the name must be 1-63 characters long and match
    the regular expression `a-z?` which means the
    first character must be a lowercase letter, and all following
    characters must be a dash, lowercase letter, or digit, except the last
    character, which cannot be a dash.
    """
    network_endpoint_type: pulumi.Output[str]
    """
    Type of network endpoints in this network endpoint group. Defaults to SERVERLESS
    Default value is `SERVERLESS`.
    Possible values are `SERVERLESS`.
    """
    project: pulumi.Output[str]
    """
    The ID of the project in which the resource belongs.
    If it is not provided, the provider project is used.
    """
    region: pulumi.Output[str]
    """
    A reference to the region where the Serverless NEGs Reside.
    """
    self_link: pulumi.Output[str]
    """
    The URI of the created resource.
    """
    def __init__(__self__, resource_name, opts=None, app_engine=None, cloud_function=None, cloud_run=None, description=None, name=None, network_endpoint_type=None, project=None, region=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a RegionNetworkEndpointGroup resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] app_engine: Only valid when networkEndpointType is "SERVERLESS".
               Only one of cloud_run, app_engine or cloud_function may be set.
               Structure is documented below.
        :param pulumi.Input[dict] cloud_function: Only valid when networkEndpointType is "SERVERLESS".
               Only one of cloud_run, app_engine or cloud_function may be set.
               Structure is documented below.
        :param pulumi.Input[dict] cloud_run: Only valid when networkEndpointType is "SERVERLESS".
               Only one of cloud_run, app_engine or cloud_function may be set.
               Structure is documented below.
        :param pulumi.Input[str] description: An optional description of this resource. Provide this property when
               you create the resource.
        :param pulumi.Input[str] name: Name of the resource; provided by the client when the resource is
               created. The name must be 1-63 characters long, and comply with
               RFC1035. Specifically, the name must be 1-63 characters long and match
               the regular expression `a-z?` which means the
               first character must be a lowercase letter, and all following
               characters must be a dash, lowercase letter, or digit, except the last
               character, which cannot be a dash.
        :param pulumi.Input[str] network_endpoint_type: Type of network endpoints in this network endpoint group. Defaults to SERVERLESS
               Default value is `SERVERLESS`.
               Possible values are `SERVERLESS`.
        :param pulumi.Input[str] project: The ID of the project in which the resource belongs.
               If it is not provided, the provider project is used.
        :param pulumi.Input[str] region: A reference to the region where the Serverless NEGs Reside.

        The **app_engine** object supports the following:

          * `service` (`pulumi.Input[str]`) - Optional serving service.
            The service name must be 1-63 characters long, and comply with RFC1035.
            Example value: "default", "my-service".
          * `urlMask` (`pulumi.Input[str]`) - A template to parse function field from a request URL. URL mask allows
            for routing to multiple Cloud Functions without having to create
            multiple Network Endpoint Groups and backend services.
            For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
            can be backed by the same Serverless NEG with URL mask "/". The URL mask
            will parse them to { function = "function1" } and { function = "function2" } respectively.
          * `version` (`pulumi.Input[str]`) - Optional serving version.
            The version must be 1-63 characters long, and comply with RFC1035.
            Example value: "v1", "v2".

        The **cloud_function** object supports the following:

          * `function` (`pulumi.Input[str]`) - A user-defined name of the Cloud Function.
            The function name is case-sensitive and must be 1-63 characters long.
            Example value: "func1".
          * `urlMask` (`pulumi.Input[str]`) - A template to parse function field from a request URL. URL mask allows
            for routing to multiple Cloud Functions without having to create
            multiple Network Endpoint Groups and backend services.
            For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
            can be backed by the same Serverless NEG with URL mask "/". The URL mask
            will parse them to { function = "function1" } and { function = "function2" } respectively.

        The **cloud_run** object supports the following:

          * `service` (`pulumi.Input[str]`) - Optional serving service.
            The service name must be 1-63 characters long, and comply with RFC1035.
            Example value: "default", "my-service".
          * `tag` (`pulumi.Input[str]`) - Cloud Run tag represents the "named-revision" to provide
            additional fine-grained traffic routing information.
            The tag must be 1-63 characters long, and comply with RFC1035.
            Example value: "revision-0010".
          * `urlMask` (`pulumi.Input[str]`) - A template to parse function field from a request URL. URL mask allows
            for routing to multiple Cloud Functions without having to create
            multiple Network Endpoint Groups and backend services.
            For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
            can be backed by the same Serverless NEG with URL mask "/". The URL mask
            will parse them to { function = "function1" } and { function = "function2" } respectively.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['app_engine'] = app_engine
            __props__['cloud_function'] = cloud_function
            __props__['cloud_run'] = cloud_run
            __props__['description'] = description
            __props__['name'] = name
            __props__['network_endpoint_type'] = network_endpoint_type
            __props__['project'] = project
            if region is None:
                raise TypeError("Missing required property 'region'")
            __props__['region'] = region
            __props__['self_link'] = None
        super(RegionNetworkEndpointGroup, __self__).__init__(
            'gcp:compute/regionNetworkEndpointGroup:RegionNetworkEndpointGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, app_engine=None, cloud_function=None, cloud_run=None, description=None, name=None, network_endpoint_type=None, project=None, region=None, self_link=None):
        """
        Get an existing RegionNetworkEndpointGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] app_engine: Only valid when networkEndpointType is "SERVERLESS".
               Only one of cloud_run, app_engine or cloud_function may be set.
               Structure is documented below.
        :param pulumi.Input[dict] cloud_function: Only valid when networkEndpointType is "SERVERLESS".
               Only one of cloud_run, app_engine or cloud_function may be set.
               Structure is documented below.
        :param pulumi.Input[dict] cloud_run: Only valid when networkEndpointType is "SERVERLESS".
               Only one of cloud_run, app_engine or cloud_function may be set.
               Structure is documented below.
        :param pulumi.Input[str] description: An optional description of this resource. Provide this property when
               you create the resource.
        :param pulumi.Input[str] name: Name of the resource; provided by the client when the resource is
               created. The name must be 1-63 characters long, and comply with
               RFC1035. Specifically, the name must be 1-63 characters long and match
               the regular expression `a-z?` which means the
               first character must be a lowercase letter, and all following
               characters must be a dash, lowercase letter, or digit, except the last
               character, which cannot be a dash.
        :param pulumi.Input[str] network_endpoint_type: Type of network endpoints in this network endpoint group. Defaults to SERVERLESS
               Default value is `SERVERLESS`.
               Possible values are `SERVERLESS`.
        :param pulumi.Input[str] project: The ID of the project in which the resource belongs.
               If it is not provided, the provider project is used.
        :param pulumi.Input[str] region: A reference to the region where the Serverless NEGs Reside.
        :param pulumi.Input[str] self_link: The URI of the created resource.

        The **app_engine** object supports the following:

          * `service` (`pulumi.Input[str]`) - Optional serving service.
            The service name must be 1-63 characters long, and comply with RFC1035.
            Example value: "default", "my-service".
          * `urlMask` (`pulumi.Input[str]`) - A template to parse function field from a request URL. URL mask allows
            for routing to multiple Cloud Functions without having to create
            multiple Network Endpoint Groups and backend services.
            For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
            can be backed by the same Serverless NEG with URL mask "/". The URL mask
            will parse them to { function = "function1" } and { function = "function2" } respectively.
          * `version` (`pulumi.Input[str]`) - Optional serving version.
            The version must be 1-63 characters long, and comply with RFC1035.
            Example value: "v1", "v2".

        The **cloud_function** object supports the following:

          * `function` (`pulumi.Input[str]`) - A user-defined name of the Cloud Function.
            The function name is case-sensitive and must be 1-63 characters long.
            Example value: "func1".
          * `urlMask` (`pulumi.Input[str]`) - A template to parse function field from a request URL. URL mask allows
            for routing to multiple Cloud Functions without having to create
            multiple Network Endpoint Groups and backend services.
            For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
            can be backed by the same Serverless NEG with URL mask "/". The URL mask
            will parse them to { function = "function1" } and { function = "function2" } respectively.

        The **cloud_run** object supports the following:

          * `service` (`pulumi.Input[str]`) - Optional serving service.
            The service name must be 1-63 characters long, and comply with RFC1035.
            Example value: "default", "my-service".
          * `tag` (`pulumi.Input[str]`) - Cloud Run tag represents the "named-revision" to provide
            additional fine-grained traffic routing information.
            The tag must be 1-63 characters long, and comply with RFC1035.
            Example value: "revision-0010".
          * `urlMask` (`pulumi.Input[str]`) - A template to parse function field from a request URL. URL mask allows
            for routing to multiple Cloud Functions without having to create
            multiple Network Endpoint Groups and backend services.
            For example, request URLs "mydomain.com/function1" and "mydomain.com/function2"
            can be backed by the same Serverless NEG with URL mask "/". The URL mask
            will parse them to { function = "function1" } and { function = "function2" } respectively.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["app_engine"] = app_engine
        __props__["cloud_function"] = cloud_function
        __props__["cloud_run"] = cloud_run
        __props__["description"] = description
        __props__["name"] = name
        __props__["network_endpoint_type"] = network_endpoint_type
        __props__["project"] = project
        __props__["region"] = region
        __props__["self_link"] = self_link
        return RegionNetworkEndpointGroup(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
